diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -23,7 +23,10 @@
  * rfbproto.c - functions to deal with client side of RFB protocol.
  */
 
+#include <sys/stat.h>
 #include <unistd.h>
+#include <time.h>
+#include <ctype.h>
 #include <errno.h>
 #include <pwd.h>
 #include <vncviewer.h>
@@ -31,6 +34,9 @@
 #include <zlib.h>
 #include <jpeglib.h>
 
+int server_major = 0, server_minor = 0;
+int viewer_major = 0, viewer_minor = 0;
+
 static void InitCapabilities(void);
 static Bool SetupTunneling(void);
 static int ReadSecurityType(void);
@@ -57,6 +63,47 @@
 static Bool HandleTight16(int rx, int ry, int rw, int rh);
 static Bool HandleTight32(int rx, int ry, int rw, int rh);
 
+/* runge add zrle */
+static Bool HandleZRLE8(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE15(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE16(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE24(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE24Up(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE24Down(int rx, int ry, int rw, int rh);
+static Bool HandleZRLE32(int rx, int ry, int rw, int rh);
+
+extern Bool HandleCursorPos(int x, int y);
+extern void printChat(char *, Bool);
+
+typedef struct {
+    unsigned long length;
+} rfbZRLEHeader;
+
+#define sz_rfbZRLEHeader 4
+
+#define rfbZRLETileWidth 64
+#define rfbZRLETileHeight 64
+
+#define DO_ZYWRLE 1
+
+#if DO_ZYWRLE
+
+#ifndef ZRLE_ONCE
+#define ZRLE_ONCE
+
+static const int bitsPerPackedPixel[] = {
+  0, 1, 2, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
+};
+
+int zywrle_level;
+int zywrleBuf[rfbZRLETileWidth*rfbZRLETileHeight];
+
+#include "zrlepalettehelper.h"
+static zrlePaletteHelper paletteHelper;
+
+#endif /* ZRLE_ONCE */
+#endif /* DO_ZYWRLE */
+
 static void ReadConnFailedReason(void);
 static long ReadCompactLen (void);
 
@@ -67,6 +114,25 @@
 static void JpegSetSrcManager(j_decompress_ptr cinfo, CARD8 *compressedData,
                               int compressedLen);
 
+extern void deskey(unsigned char *, int);
+extern void des(unsigned char *, unsigned char *);
+
+extern int currentMsg;
+extern double scale_factor_x;
+extern double scale_factor_y;
+
+extern int skip_maybe_sync;
+
+int sent_FBU = 0;
+int skip_XtUpdate = 0;
+int skip_XtUpdateAll = 0;
+
+static double dt_out = 0.0;
+static double dt_out_sc = 0.0;
+double latency = 0.0;
+double connect_time = 0.0;
+
+void raiseme(int force);
 
 int rfbsock;
 char *desktopName;
@@ -75,6 +141,14 @@
 char *serverCutText = NULL;
 Bool newServerCutText = False;
 
+/* ultravnc mslogon */
+#define rfbUltraVncMsLogon 0xfffffffa
+static Bool AuthUltraVncMsLogon(void);
+extern void UvncEncryptPasswd_MSLOGON(unsigned char *encryptedPasswd, char *passwd);
+extern void UvncEncryptBytes2(unsigned char *where, int length, unsigned char *key);
+extern void UvncDecryptBytes2(unsigned char *where, int length, unsigned char *key);
+extern unsigned int urandom(void);
+
 int endianTest = 1;
 
 static Bool tightVncProtocol = False;
@@ -177,8 +251,26 @@
 	  sig_rfbEncodingPointerPos, "Pointer position update");
   CapsAdd(encodingCaps, rfbEncodingLastRect, rfbTightVncVendor,
 	  sig_rfbEncodingLastRect, "LastRect protocol extension");
+
+  CapsAdd(encodingCaps, rfbEncodingNewFBSize, rfbTightVncVendor,
+	  sig_rfbEncodingNewFBSize, "New FB size protocol extension");
+
+#ifdef TURBOVNC
+  CapsAdd(encodingCaps, rfbJpegQualityLevel1, rfbTurboVncVendor,
+	  sig_rfbEncodingNewFBSize, "TurboJPEG quality level");
+  CapsAdd(encodingCaps, rfbJpegSubsamp1X, rfbTurboVncVendor,
+	  sig_rfbEncodingNewFBSize, "TurboJPEG subsampling level");
+#endif
 }
 
+static char msgbuf[10000];
+
+static void wmsg(char *msg, int wait) {
+	fprintf(stderr, "%s", msg);
+	if (!use_tty() && !getenv("SSVNC_NO_MESSAGE_POPUP")) {
+		CreateMsg(msg, wait);
+	}
+}
 
 /*
  * ConnectToRFBServer.
@@ -187,24 +279,179 @@
 Bool
 ConnectToRFBServer(const char *hostname, int port)
 {
-  unsigned int host;
-
-  if (!StringToIPAddr(hostname, &host)) {
-    fprintf(stderr,"Couldn't convert '%s' to host address\n", hostname);
-    return False;
-  }
+	char *q, *cmd = NULL;
+	Bool setnb;
+	struct stat sb;
+
+	if (strstr(hostname, "exec=") == hostname) {
+		cmd = strdup(hostname);
+		q = strchr(cmd, '=');
+		*q = ' ';
+		if (getenv("SSVNC_BASEDIR")) {
+			char *base = getenv("SSVNC_BASEDIR");
+			char *newcmd = (char *)malloc(strlen(base) + strlen(cmd) + 1000);	
+			sprintf(newcmd, "%s/unwrap.so", base);
+			if (stat(newcmd, &sb) == 0) {
+#if (defined(__MACH__) && defined(__APPLE__))
+				sprintf(newcmd, "DYLD_FORCE_FLAT_NAMESPACE=1; export DYLD_FORCE_FLAT_NAMESPACE; DYLD_INSERT_LIBRARIES='%s/unwrap.so'; export DYLD_INSERT_LIBRARIES; %s", base, cmd);
+#else
+				sprintf(newcmd, "LD_PRELOAD='%s/unwrap.so'; export LD_PRELOAD; %s", base, cmd);
+#endif
+				cmd = newcmd;
+			}
+		}
+	}
 
-  rfbsock = ConnectToTcpAddr(host, port);
+	if (cmd != NULL) {
+		int sfd[2];
+		char *q, *cmd2 = strdup(cmd);
+		pid_t pid;
+
+		q = strstr(cmd2, "pw=");
+		if (q && !getenv("SSVNC_SHOW_ULTRAVNC_DSM_PASSWORD")) {
+			q += strlen("pw=");
+			while (*q != '\0' && !isspace(*q)) {
+				*q = '*';
+				q++;
+			}
+		}
+
+		fprintf(stderr, "exec-cmd: %s\n\n", cmd2);
+		free(cmd2);
+
+		if (! SocketPair(sfd)) {
+			return False;
+		}
+		if (0) {
+			fprintf(stderr, "sfd: %d %d\n", sfd[0], sfd[1]);
+			fflush(stderr);
+		}
+
+		pid = fork();
+		if (pid == -1) {
+			perror("fork");
+			return False;
+		}
+		if (pid == 0) {
+			char *args[4];
+			int d;
+			args[0] = "/bin/sh";
+			args[1] = "-c";
+			args[2] = cmd;
+			args[3] = NULL;
+
+			close(sfd[1]);
+			dup2(sfd[0], 0);
+			dup2(sfd[0], 1);
+			for (d=3; d < 256; d++) {
+				if (d != sfd[0]) {
+					close(d);
+				}
+			}
+			execvp(args[0], args);
+			perror("exec");
+			exit(1);
+		} else {
+			close(sfd[0]);
+			rfbsock = sfd[1];
+		}
+		if (rfbsock < 0) {
+			sprintf(msgbuf,"Unable to connect to exec'd command: %s\n", cmd);
+			wmsg(msgbuf, 1);
+			return False;
+		}
+	} else if (strstr(hostname, "fd=") == hostname) {
+		rfbsock = atoi(hostname + strlen("fd="));
+	} else if (strchr(hostname, '/') && stat(hostname, &sb) == 0) {
+		/* assume unix domain socket */
+		char *thost = strdup(hostname); 
+
+		rfbsock = ConnectToUnixSocket(thost);
+		free(thost);
+
+		if (rfbsock < 0) {
+			sprintf(msgbuf,"Unable to connect to VNC server (unix-domain socket: %s)\n", hostname);
+			wmsg(msgbuf, 1);
+			return False;
+		}
+		
+	} else {
+		rfbsock = ConnectToTcpAddr(hostname, port);
+
+		if (rfbsock < 0 && !appData.noipv4) {
+			char *q, *hosttmp;
+			if (hostname[0] == '[') {
+				hosttmp = strdup(hostname+1);
+			} else {
+				hosttmp = strdup(hostname);
+			}
+			q = strrchr(hosttmp, ']');
+			if (q) *q = '\0';
+			if (strstr(hosttmp, "::ffff:") == hosttmp || strstr(hosttmp, "::FFFF:") == hosttmp) {
+				char *host = hosttmp + strlen("::ffff:");
+				if (dotted_ip(host, 0))  {
+					fprintf(stderr, "ConnectToTcpAddr[ipv4]: re-trying connection using '%s'\n", host);
+					rfbsock = ConnectToTcpAddr(host, port);
+				}
+			}
+			free(hosttmp);
+		}
+
+		if (rfbsock < 0) {
+			sprintf(msgbuf,"Unable to connect to VNC server (%s:%d)\n", hostname, port);
+			wmsg(msgbuf, 1);
+			return False;
+		}
+	}
 
-  if (rfbsock < 0) {
-    fprintf(stderr,"Unable to connect to VNC server\n");
-    return False;
-  }
+	setnb = SetNonBlocking(rfbsock);
+	return setnb;
+}
 
-  return SetNonBlocking(rfbsock);
+static void printFailureReason(void) {
+	CARD32 reasonLen;
+	ReadFromRFBServer((char *)&reasonLen, 4);
+	reasonLen = Swap32IfLE(reasonLen);
+	if (reasonLen < 4096) {
+		char *reason = (char *) malloc(reasonLen+1);
+		memset(reason, 0, reasonLen+1);
+		ReadFromRFBServer(reason, reasonLen);
+		sprintf(msgbuf, "Reason: %s\n", reason);
+		wmsg(msgbuf, 1);
+		free(reason);
+	}
 }
 
+static char *pr_sec_type(int type) {
+	char *str = "unknown";
+	if (type == rfbSecTypeInvalid) str = "rfbSecTypeInvalid";
+	if (type == rfbSecTypeNone) str = "rfbSecTypeNone";
+	if (type == rfbSecTypeVncAuth) str = "rfbSecTypeVncAuth";
+	if (type == rfbSecTypeRA2) str = "rfbSecTypeRA2";
+	if (type == rfbSecTypeRA2ne) str = "rfbSecTypeRA2ne";
+	if (type == rfbSecTypeTight) str = "rfbSecTypeTight";
+	if (type == rfbSecTypeUltra) str = "rfbSecTypeUltra";
+
+	if (type == rfbSecTypeAnonTls) str = "rfbSecTypeAnonTls";
+	if (type == rfbSecTypeVencrypt) str = "rfbSecTypeVencrypt";
+
+	if (type == (int) rfbUltraVncMsLogon) str = "rfbUltraVncMsLogon";
+	return str;
+}
+
+static char *pr_sec_subtype(int type) {
+	char *str = "unknown";
+	if (type == rfbVencryptPlain) str = "rfbVencryptPlain";
+	if (type == rfbVencryptTlsNone) str = "rfbVencryptTlsNone";
+	if (type == rfbVencryptTlsVnc) str = "rfbVencryptTlsVnc";
+	if (type == rfbVencryptTlsPlain) str = "rfbVencryptTlsPlain";
+	if (type == rfbVencryptX509None) str = "rfbVencryptX509None";
+	if (type == rfbVencryptX509Vnc) str = "rfbVencryptX509Vnc";
+	if (type == rfbVencryptX509Plain) str = "rfbVencryptX509Plain";
+	return str;
+}
 
+extern void ProcessXtEvents(void);
 /*
  * InitialiseRFBConnection.
  */
